/*****************************************************************************/

import java.applet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.awt.geom.*;

/*****************************************************************************/

class Fenetre extends JFrame
	{
	/* paneaux */
	private CadreImage image;
	private CadreChoix choix;
	private CadreStats stats;
	private CadreStats statsGen;
	private CadreTexte texte;
	private JScrollPane scrollImage;
	
	public Fenetre(String titre)
		{
		super(titre);
		Container c = getContentPane();
		c.setLayout(new BorderLayout());
				
		/* menu */
		JMenuBar menu = new JMenuBar();
		setJMenuBar(menu);
        
        /* menu action */        
		JMenu menuAction = new JMenu(Lang.tMenuAction);
		menu.add(menuAction);
		
		JMenuItem mTuer = new JMenuItem(Lang.tTuer);
		mTuer.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.tuer();} });
		addMenuItem(mTuer, menuAction, 'T', 'T', Lang.aTuer);
		
		JMenuItem mRevive = new JMenuItem(Lang.tRevive);
		mRevive.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.revive();} });
		addMenuItem(mRevive, menuAction, 'R', 'R', Lang.aRevive);
		
		JMenuItem mPoly = new JMenuItem(Lang.tPoly);
		mPoly.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.poly();} });
		addMenuItem(mPoly, menuAction, 'M', 'M', Lang.aPoly);
		
		JMenuItem mNonArme = new JMenuItem(Lang.tNonArme);
		mNonArme.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.desarmer();} });
		addMenuItem(mNonArme, menuAction, 'D', 'D', Lang.aNonArme);
		
		JMenuItem mHache = new JMenuItem(Lang.tHache);
		mHache.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.armer();} });
		addMenuItem(mHache, menuAction, 'H', 'H', Lang.aHache);
		
		/* menu gestion */
		JMenu menuGestion = new JMenu(Lang.tMenuGestion);
		menu.add(menuGestion);
		
		JMenuItem mNew = new JMenuItem(Lang.tNew);
		mNew.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {Peon.add();} });
		addMenuItem(mNew, menuGestion, 'N', 'N', Lang.aNew);
		
		JMenuItem mSuppr = new JMenuItem(Lang.tSuppr);
		mSuppr.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e)	{BarbiePeon.peonCourrant.suppr();} });
		addMenuItem(mSuppr, menuGestion, 'S', 'S', Lang.aSuppr);
		
		/* menu ? */
		JMenu menuInter = new JMenu(Lang.tMenuInter);
		menu.add(menuInter);
		
		JMenuItem mAbout = new JMenuItem(Lang.tAbout);
		mAbout.addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e) {JOptionPane.showMessageDialog(null, Lang.mAbout, Lang.tAbout, JOptionPane.INFORMATION_MESSAGE);} });
		addMenuItem(mAbout, menuInter, 'A', 'A', "");
		
        /* paneaux */
		image = new CadreImage(); 
		scrollImage = new JScrollPane(image);
		c.add(scrollImage, "Center");
		choix = new CadreChoix();
		c.add(choix, "South");
		stats = new CadreStats(false);        
		c.add(stats, "West");
		statsGen = new CadreStats(true);        
		c.add(statsGen, "East");
		texte = new CadreTexte();
		c.add(texte, "North");
		}
	
	private void addMenuItem(JMenuItem jm, JMenu menu, char acce, char mnem, String tip)
		{
		menu.add(jm);
		jm.setAccelerator(KeyStroke.getKeyStroke(acce, 2));
		jm.setMnemonic(mnem);
		jm.setToolTipText(tip);
		}
	
	/* methodes get */
	public CadreImage getImage() {return image;}
	public CadreTexte getTexte() {return texte;}
	public CadreStats getStats() {return stats;}
	public CadreStats getStatsGen() {return statsGen;}
	public JScrollPane getScrollImage() {return scrollImage;}
	}

/*****************************************************************************/

class CadreChoix extends JPanel
	{
	private JButton hache = new JButton(FImages.bHache1);
	private JButton nonArme = new JButton(FImages.bNonArme);
	private JButton poly = new JButton(FImages.bPoly);
	private JButton tuer = new JButton(FImages.bTuer);
	private JButton revive = new JButton(FImages.bRevive);
	
	public CadreChoix()
		{
		setLayout(new FlowLayout());

		hache.addActionListener(new ActionListener() 
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.armer();} });
		add(hache);
		hache.setToolTipText(Lang.aHache);

		nonArme.addActionListener(new ActionListener() 
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.desarmer();} });
		add(nonArme);
		nonArme.setToolTipText(Lang.aNonArme);
		
		poly.addActionListener(new ActionListener() 
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.poly();} });
		add(poly);
		poly.setToolTipText(Lang.aPoly);
		
		tuer.addActionListener(new ActionListener() 
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.tuer();} });
		add(tuer);
		tuer.setToolTipText(Lang.aTuer);
		
		revive.addActionListener(new ActionListener() 
			{public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.revive();} });
		add(revive);
		revive.setToolTipText(Lang.aRevive); 
		}
	/*
	public CadreChoix()
		{
		setLayout(new FlowLayout());

		JComboBox coulTenue = new JComboBox(Lang.liste_coulTenue);
		add(coulTenue);

		JCheckBox arme = new JCheckBox(Lang.arme, false);
		add(arme);

		JButton ok = new JButton("OK");
		add(ok);
		}
	*/
	}

/*****************************************************************************/

class CadreImage extends JPanel
	{
	public CadreImage()
		{
		}
	}

/*****************************************************************************/

class CadreStats extends JPanel
	{
	private JLabel titreMort;
	private JLabel titrePoly;
	private JLabel titreCadre;
	private JLabel barre;
	boolean gen;
	
	public CadreStats(boolean gen)
		{
		barre = new JLabel(Lang.statSeparator);
		add(barre);
		
		this.gen = gen;
		setLayout(new GridLayout(5,1));
		
		if(gen)	{titreCadre = new JLabel(Lang.statTitreGen);}
		else {titreCadre = new JLabel(Lang.statTitreInd);}
		add(titreCadre);
		
		titreMort = new JLabel(Lang.statTitreMort);
		if(gen) 
			{
			titreMort.setToolTipText(Lang.asMortGen);
			setMorts(Peon.getNbMortsGen());
			}
		else {titreMort.setToolTipText(Lang.asMort);}
		add(titreMort);
		
		titrePoly = new JLabel(Lang.statTitrePoly);
		if(gen) 
			{
			titrePoly.setToolTipText(Lang.asPolyGen);
			setPoly(Peon.getNbPolyGen());
			}
		else {titrePoly.setToolTipText(Lang.asPoly);}
		add(titrePoly);
		}

	/* methodes set */
	public void setMorts(int nb) {titreMort.setText(Lang.statTitreMort + nb);}
	public void setPoly(int nb) {titrePoly.setText(Lang.statTitrePoly + nb);}
	}

/*****************************************************************************/

class CadreTexte extends JPanel
	{
	private JLabel text;
	
	public CadreTexte()
		{
		text = new JLabel(Lang.txtDebut);
		add(text);
		}
	
	public void changeTexte(String text)
		{
		this.text.setText(text);
		}
	}


/*****************************************************************************/

class Peon implements ActionListener
	{
	private JButton image;
	private boolean vivant;
	private String forme;
	/* stats */
	private static int nbMortsGen = 0;
	private int nbMorts;
	private static int nbPolyGen = 0;
	private int nbPoly;
	private String nom;

	public Peon()
		{
		image = new JButton(FImages.iPeon_R_N);
		image.addActionListener(this);
		image.setBackground(Color.black);
		image.setSize(35,35);
		image.setToolTipText(Lang.aSelectPeon);
		vivant = true;
		forme = "peon";
		nbMorts = 0;
		nbPoly = 0;		
		}
		
	public void suppr()
		{
		if(BarbiePeon.peons.size()>1) 
			{
			BarbiePeon.peons.remove(BarbiePeon.peons.indexOf(this));
			BarbiePeon.peonCourrant = (Peon)BarbiePeon.peons.get(0);
			BarbiePeon.fen.getImage().remove(getImage());
			BarbiePeon.fen.getImage().validate();
			BarbiePeon.fen.getTexte().changeTexte(Lang.txtSuppr);
			BarbiePeon.fen.getScrollImage().updateUI();
			}
		else {JOptionPane.showMessageDialog(null, Lang.erPeonSeul, Lang.erTitre, JOptionPane.ERROR_MESSAGE);}
		}
	
	public static void add()
		{
		BarbiePeon.peonCourrant = new Peon();
		BarbiePeon.peons.add(BarbiePeon.peonCourrant);
		BarbiePeon.fen.getImage().add(BarbiePeon.peonCourrant.getImage());
		BarbiePeon.fen.getImage().validate();
		BarbiePeon.fen.getTexte().changeTexte(Lang.txtAdd);
		BarbiePeon.fen.getStats().setMorts(BarbiePeon.peonCourrant.getNbMorts());
		BarbiePeon.fen.getStats().setPoly(BarbiePeon.peonCourrant.getNbPoly());
		BarbiePeon.fen.getScrollImage().updateUI();
		}

	public void tuer() 
		{
		if(testVivant())
			{
			vivant = false;
			forme = "peon"; 
			image.setIcon(FImages.iPeon_R_M);
			nbMorts++;
			nbMortsGen++;
			BarbiePeon.fen.getStats().setMorts(nbMorts);
			BarbiePeon.fen.getStatsGen().setMorts(nbMortsGen);
			BarbiePeon.fen.getTexte().changeTexte(Lang.txtTuer);
			}
		}
        
	public void revive() 
		{
		if(testMort())
			{
			vivant = true; 
			image.setIcon(FImages.iPeon_R_N);
			BarbiePeon.fen.getTexte().changeTexte(Lang.txtRevive);
			}
		}
	
	public void armer()
		{
		if((testFormePeon())&&(testVivant()))
			{
			image.setIcon(FImages.iPeon_R_H);
			BarbiePeon.fen.getTexte().changeTexte(Lang.txtArme);
			}
		}
	
	public void desarmer()
		{
		if((testFormePeon())&&(testVivant())) 
			{
			image.setIcon(FImages.iPeon_R_N);
			BarbiePeon.fen.getTexte().changeTexte(Lang.txtNonArme);
			}
		}
	
	public void poly()
		{
		if((testFormePeon())&&(testVivant())) 
			{
			forme = "mouton";
			image.setIcon(FImages.iMout_1);
			nbPoly++;
			nbPolyGen++;
			BarbiePeon.fen.getStats().setPoly(nbPoly);
			BarbiePeon.fen.getStatsGen().setPoly(nbPolyGen);
			BarbiePeon.fen.getTexte().changeTexte(Lang.txtPoly);
			}
		}
	
	/* methodes de tests */	
	private boolean testFormePeon()
		{
		if(forme.equals("mouton"))
			{
			JOptionPane.showMessageDialog(null, Lang.erMouton, Lang.erTitre, JOptionPane.ERROR_MESSAGE);
			return false;
			}
		return true;
		}
	
	private boolean testVivant()
		{
		if(!vivant())
			{
			JOptionPane.showMessageDialog(null, Lang.erPeonMort, Lang.erTitre, JOptionPane.ERROR_MESSAGE);
			return false;
			}
		return true;
		}
	
	private boolean testMort()
		{
		if(vivant())
			{
			JOptionPane.showMessageDialog(null, Lang.erPeonVivant, Lang.erTitre, JOptionPane.ERROR_MESSAGE);
			return false;
			}
		return true;
		}
	/* methodes get */	
	public boolean vivant()	{return vivant;}
	public JButton getImage() {return image;}
	public int getNbMorts() {return nbMorts;}
	public int getNbPoly() {return nbPoly;}
	public static int getNbMortsGen() {return nbMortsGen;}
	public static int getNbPolyGen() {return nbPolyGen;}
	
	/* action performed */
	public void actionPerformed(ActionEvent e) 
		{
		BarbiePeon.peonCourrant = this;
		BarbiePeon.fen.getStats().setMorts(nbMorts);
		BarbiePeon.fen.getStats().setPoly(nbPoly);
		}		
	}

/*****************************************************************************/

public class BarbiePeon
	{
	static int largeurFenetre = 500;
	static int hauteurFenetre = 215;
	static ArrayList peons;
	static Peon peonCourrant;
	static Fenetre fen;

	public static void main(String[] args)
		{
		JOptionPane.showMessageDialog(null, Lang.about_message, Lang.about_titre, JOptionPane.INFORMATION_MESSAGE);
		fen = new Fenetre(Lang.fenTitre);
		
		peons = new ArrayList();	
		Peon.add();
		
				
		fen.setBounds(150, 200, largeurFenetre, hauteurFenetre);
		fen.setVisible(true);
		}
	}

/*****************************************************************************/

class Lang
	{
	/* divers */
	static String dVersion = "0.3";
	
	/* dans BarbiePeon */
	static String fenTitre = "Barbie-Peon (Beta version " + Lang.dVersion + ")";
	static String about_titre = "About "+fenTitre;
	static String about_message = "Barbie-Peon est un logiciel indispenssable par excellence ! "+
		" En effet, il permet d'habiller des peons, comme de vraies poupes !"+
		"\n\nLiscence d'utilisation : \n"+
		"- Ce logiciel est (trs)Cherware. "+
		"Si vous l'utilisez plus de 10 secondes, "+
		"merci de m'envoyer un chque de 75238.\n"+
		"- Le prix indiqu esr videnment par minute"+
		" d'utilsation, mais tais-ce bien utile de le preciser ?";
        
	/* dans CadreChoix */
	static String[] liste_coulTenue = {"Bleu", "Rouge", "Jaune", "Violet"/*, "Nu"*/};
	static String arme = "Arm";
	static String nArme = "Non arm";

	/* dans CadrePeon */
	static String votrePeon = "Vos peons :";
	
	/* menu action */
	static String tMenuAction = "Actions";
	static String tTuer = "Tuer";
	static String tRevive = "Ressuciter";
	static String tPoly = "Moutonmorphoser";
	static String tHache = "Armer";
	static String tNonArme = "Dsarmer";
	static String aTuer = "Tuer ce peon.";
	static String aRevive = "Ressuciter ce peon.";
	static String aPoly = "Changer ce peon en mouton.";
	static String aHache = "Donner une hache  ce peon.";
	static String aNonArme = "Reprendre sa hache  ce peon.";
	/* menu gestion */
	static String tMenuGestion = "Gestion";
	static String tNew = "Nouveau";
	static String tSuppr = "Supprimer";
	static String aNew = "Crer un nouveau peon.";
	static String aSuppr = "Supprimer ce peon.";
	/* menu ? */
	static String tMenuInter = "?";
	static String tAbout = "A propos de BarbiePeon";
	static String mAbout = "Vous utilisez la version " + Lang.dVersion + " de BarbiePeon.\n\n" +
		"Logiciel dvelopp par Darathor.\n" +
		"     email : darathor@free.fr\n" +
		"     site : http://darathor.free.fr\n\n" +
		"Les images des peons sont tires du jeu Warcraft2 dvellop par Blizzard.\n" +
		"     http://www.blizzard.com";
		
	/* tip texts */
	static String aSelectPeon = "Slectionner ce peon.";

	/* messages d'erreurs */
	static String erTitre = "Action impossible";
	static String erPeonMort = "Impossible, ce peon est mort !";
	static String erPeonVivant = "Impossible, ce peon est encore en vie !";
	static String erPeonSeul = "Vous ne pouvez pas avoir moins d'un peon !";
	static String erMouton = "Ce peon est un mouton ! Seule la mort pourra l'en dlivrer...";
	
	/* message du cadre texte */
	static String txtDebut = "Bienvenue dans BarbiePeon ! Votre premier peon vien d'tre cr.";
	static String txtTuer = "Que cet acte ignoble hante vos nuits jusqu' la fin de vos jours !";
	static String txtRevive = "Je vois que vous avez des remords...";
	static String txtArme = "Peon arm !";
	static String txtNonArme = "Peon dsarm.";
	static String txtAdd = "Nouveu pon prt !";
	static String txtSuppr = "Ce peon est retourn au nant...";
	static String txtPoly = "Ce peon est un mouton maintenant...";
	
	/* cadre stats */
	static String statSeparator = " ------------------ ";
	static String statTitreGen = " Collectives ";
	static String statTitreInd = " Individuelles ";
	static String statTitreMort = "   Morts : ";
	static String asMort = "Ce compteur indique combien de fois ce peon est mort.";
	static String asMortGen = "Ce compteur indique combien de fois qu'un peon est mort.";
	static String statTitrePoly = "   Mouton : ";
	static String asPoly = "Ce compteur indique combien de fois ce peon a t Moutonmorphos.";
	static String asPolyGen = "Ce compteur indique combien de fois q'un peon a t Moutonmorphos.";
	}

/*****************************************************************************/

class FImages
	{
	/* Image */
	static Image peonTete = Toolkit.getDefaultToolkit().getImage("peon.gif");
	static Image peon_R_N = Toolkit.getDefaultToolkit().getImage("peon_r_n.gif");
	static Image peon_R_H = Toolkit.getDefaultToolkit().getImage("peon_r_h.gif");
	static Image peon_R_M = Toolkit.getDefaultToolkit().getImage("peon_r_m.gif");
	
	static Image fBrun1 = Toolkit.getDefaultToolkit().getImage("fond01.gif");
	
	/* ImageIcon */
	static ImageIcon iPeonTete = new ImageIcon("peon.gif");
	static ImageIcon iPeon_R_N = new ImageIcon("peon_r_n.gif");
	static ImageIcon iPeon_R_H = new ImageIcon("peon_r_h.gif");
	static ImageIcon iPeon_R_M = new ImageIcon("peon_r_m.gif");
	static ImageIcon iMout_1 = new ImageIcon("mout_1.gif");
	
	static ImageIcon bPoly = new ImageIcon("iconMouton01.gif");
	static ImageIcon bHache1 = new ImageIcon("iconHache01.gif");
	static ImageIcon bNonArme = new ImageIcon("iconSymbole01.gif");
	static ImageIcon bTuer = new ImageIcon("iconMort01.gif");
	static ImageIcon bRevive = new ImageIcon("iconRevive01.gif");
	}

/*****************************************************************************/